//DistIr.h  Libraire capteur IR pour interruption

volatile byte distIrG,distIrD; // 0 .. 255

#define bDistG  0 //PORTC  pin14
#define bDistD  1 //PORTC  pin15
#define bLedIr  2 //PORTC  pin16
#define DirLedIr  DDRC |= 1<< bLedIr  // sortie
#define LedIrOn   bitSet   (PORTC,bLedIr)
#define LedIrOff  bitClear (PORTC,bLedIr)

#define mCadist (1<<bDistG | 1<< bDistD) 
#define ModeCha   DDRC  |=  mCadist; PORTC |=  mCadist 
#define ModeMes   DDRC  &= ~mCadist; PORTC &= ~mCadist
#define CapaGHigh PINC  & 1<<bDistG
#define CapaDHigh PINC  & 1<<bDistD

void SetupDistIr () {   
   DirLedIr; 
   LedIrOn;   
   ModeMes; 
}
volatile byte cnti, cntG,cntD;
enum {Istart,Iatt,Icnt,Ifin} eIr=Istart;
void DoDistIr () {  // cycle de 17us
 cnti++;
 switch(eIr) {
   case Istart:
   ModeCha;  // precharge
   cnti=0;
   eIr= Iatt;
   break;
  case Iatt:
   ModeMes;
   cntG = 0 ;  cntD = 0 ;
   eIr= Icnt;
   break;   
  case Icnt:
   if (CapaGHigh)  cntG++ ;
   if (CapaDHigh)  cntD++ ;
   if (cnti>63) eIr= Ifin;   // modif 
   break;
  case Ifin:
   distIrG = cntG;
   distIrD = cntD;
   eIr = Istart;
   break;
 }  // end switch
}
